# Einsatz Online
Build status (develop branch): 
[![builds.sr.ht status](https://builds.sr.ht/~anghenfil.svg)](https://builds.sr.ht/~anghenfil?search=)
![project status](https://www.repostatus.org/badges/latest/wip.svg)

## Über Einsatz Online
Einsatz Online ist eine Plattform für Hilfsorganisationen, Feuerwehren und ähnlichen ehrenamtlichen Strukturen und soll Verwaltungsaufgaben erleichtern & digitalisieren. Dazu zählt unter anderem die Verwaltung von Personaldaten, Fahrzeugen und geplanten Einsätzen.
Künftig soll Einsatz Online zudem die Alarmierung und Einsatzführung vor Ort unterstützen.

## Eigenschaften
* vollständig & für immer Open Source (APGLv3)
* modulare Software
* starkes Rechtesystem um Privatsphäre & Daten zu schützen

## Mitmachen
Sehr gerne könnt ihr mich bei diesem Projekt unterstützen. Das untenstehende Developer Setup hilft euch, eine Grundinstallation von Einsatz Online einzurichten. Ich freue mich über Pull Requests oder Issues!


## Developer Setup
* Voraussetzungen: [Rust Toolchain](https://rustup.rs/), [PostgreSQL Server](https://www.postgresql.org/)
* Clone dieses Git Repository
* Verzeichnis betreten
* Kopiere config/default.toml nach config/development.toml
* "connection_string" in der Konfiguration entsprechend anpassen. z.B. ```postgresql://postgresuser:password@localhost:5432/postgres```
* Diesel CLI installieren: ```cargo install diesel_cli```
* Diesel CLI Datenbank einrichten: ```diesel setup --database-url='CONNECTION_STRING_HERE'```
* Datenbank einrichten: ```diesel migration run```
* Mit [cargo build](https://doc.rust-lang.org/cargo/commands/cargo-build.html) Einsatz Online bauen
* Mit [cargo run](https://doc.rust-lang.org/cargo/commands/cargo-run.html) Einsatz Online starten.

## Dokumentation
* Derzeit ist die Dokumentation noch nicht online verfügbar (coming soon).
* Ihr könnt das Repository clonen & die [Rust Toolchain einrichten](https://rustup.rs/) und anschließend mit cargo doc die Dokumentation bauen. 

## Zeitplan/Timetable
**Version 0.1:**
* core system (erledigt)
* Mitgliedsverwaltung (erledigt)
* Gruppen & Rollen (erledigt)
* E-Mail Versand an Gruppen & Einheiten (erledigt)

**Version 0.2: **
* Fahrzeugverwaltung (nur Basisfunktionen) (erledigt)
* Verwaltung geplanter Einsätze (erledigt)
* Veranstalter verwalten (erledigt)

**Version 0.3:**
* Abrechnung geplanter Einsätze (WIP)
* erweiterte Fahrzeugverwaltung
* API für externe Anwendungen

**geplant für spätere Versionen: **
* eingenständiges Alarmierungssystem
* Module für Einsatzführung (Lagekarte, Einsatztagebuch, Kräfteübersicht)
* Exportfunktionen
* Erweiterung Mitgliedermodul
* Materialverwaltungsmodul
* Übersetzungen
* Docker Image

## Kontakt Maintainer:
* anghenfil
* E-Mail/Delta-Chat: ares@anghenfil.de