-- Your SQL goes here
create table event_organisers
(
    entity_id uuid not null
        constraint event_organisers_pk
            primary key
        constraint event_organisers_entities_entity_id_fk
            references entities
            on update cascade on delete cascade,
    company text,
    firstname text,
    lastname text,
    phone text,
    email text,
    other text
);

INSERT INTO permissions (permission, description)
VALUES ('modules.event_management.organisers.view', 'Permission to view all event organisers');
INSERT INTO permissions (permission, description)
VALUES ('modules.event_management.organisers.edit', 'Permission to edit all event organisers');
INSERT INTO permissions (permission, description)
VALUES ('modules.event_management.organisers.create', 'Permission to create a new event organiser');
INSERT INTO permissions (permission, description)
VALUES ('modules.event_management.organisers.delete', 'Permission to delete all event organisers');
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.organisers.view', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.organisers.edit', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.organisers.delete', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.organisers.create', DEFAULT);