-- Your SQL goes here
create table event_requests
(
    entity_id uuid not null
        constraint event_requests_pk
            primary key
        constraint event_request_entities_entity_id_fk
            references entities
            on update cascade on delete cascade,
    name text not null,
    timescale text,
    site text,
    organiser_id uuid,
    etype uuid,
    related_group uuid
        constraint event_requests_groups_entity_id_fk
            references groups,
    contact_on_site_name text,
    contact_on_site_phone text,
    specials text,
    requested text,
    expected_attendees integer,
    risk_potential integer,
    state smallint default 0 not null,
    received timestamp default now() not null
);

INSERT INTO permissions (permission, description, context)
VALUES ('modules.event_management.requests.view', 'Permission to see all event requests', false);
INSERT INTO permissions (permission, description, context)
VALUES ('modules.event_management.requests.edit', 'Permission to modify event requests', false);
INSERT INTO permissions (permission, description, context)
VALUES ('modules.event_management.requests.delete', 'Permission to delete event requests', false);
INSERT INTO permissions (permission, description, context)
VALUES ('modules.event_management.requests.create', 'Permission to create new event requests', false);
INSERT INTO permissions (permission, description, context, context_type)
VALUES ('modules.event_management.requests.assignments.assign', 'Permission to assign requests to a group', true, 'groups');
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.requests.view', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.requests.edit', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.requests.delete', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.requests.create', DEFAULT);
INSERT INTO roles_permissions (role_id, permission_id, role_permission_id)
VALUES ('admin', 'modules.event_management.requests.assignments.assign', DEFAULT);

alter table events
    add related_request uuid;
alter table events
    add state smallint default 0 not null;

