-- Your SQL goes here
create table log_actions
(
    action      text
        constraint log_actions_pk
            primary key,
    description text
);

create table log
(
    entry_id        serial
        constraint log_pk
            primary key,
    timestamp       timestamptz default now() not null,
    action          text                      not null,
    affected_entity uuid
        constraint log_entities_entity_id_fk_2
            references entities
            on update cascade,
    causer          uuid
        constraint log_entities_entity_id_fk
            references entities
            on update cascade,
    details         jsonb
);

CREATE INDEX ON log USING gin(details);

INSERT INTO log_actions (action, description)
VALUES ('password_reset', null);
INSERT INTO log_actions (action, description)
VALUES ('billing_state_approved', null);
