$( document ).ready(function() {
    Communicator.load_groups();
    Communicator.load_units();
    $("#send-email-submit").on("click", Communicator.send_email);
    $(".email-to-searchbar").on('keyup', function(event){
        if(event.key === "Enter"){
            $(".email-to-searchbar-overlay").children("li").first().trigger("click");
            $(".email-to-searchbar").val("");
        }
        QuickSearch.handle_typing(QuickSearch.SEARCHTYPE.MEMBER, ".email-to-searchbar", ".email-to-searchbar-overlay", "email-to-searchbar-overlay-result", "#email-to");
    });
    $(".email-to-searchbar-overlay").on("focusout", function (){
        $(".email-to-searchbar-overlay").hide();
    })
    $(".email-to-searchbar-overlay").on("mouseleave", function (){
        $(".email-to-searchbar-overlay").hide();
    });
    $(".email-to-search").on("mouseenter", function (){
        $(".email-to-searchbar-overlay").show();
    });
    $(".email-to-search").on("focusin", function (){
        $(".email-to-searchbar-overlay").html("");
    });
    $(".email-to-searchbar").on("click", function (){
        $(".email-to-searchbar").val("");
    });

    $(".email-cc-searchbar").on('keyup', function(event){
        if(event.key === "Enter"){
            $(".email-cc-searchbar-overlay").children("li").first().trigger("click");
            $(".email-cc-searchbar").val("");
        }
        QuickSearch.handle_typing(QuickSearch.SEARCHTYPE.MEMBER, ".email-cc-searchbar", ".email-cc-searchbar-overlay", "email-cc-searchbar-overlay-result", "#email-cc");
    });
    $(".email-cc-searchbar-overlay").on("focusout", function (){
        $(".email-cc-searchbar-overlay").hide();
    })
    $(".email-cc-searchbar-overlay").on("mouseleave", function (){
        $(".email-cc-searchbar-overlay").hide();
    });
    $(".email-cc-search").on("mouseenter", function (){
        $(".email-cc-searchbar-overlay").show();
    });
    $(".email-cc-search").on("focusin", function (){
        $(".email-cc-searchbar-overlay").html("");
    });
    $(".email-cc-searchbar").on("click", function (){
        $(".email-cc-searchbar").val("");
    });

    $(".email-bcc-searchbar").on('keyup', function(event){
        if(event.key === "Enter"){
            $(".email-bcc-searchbar-overlay").children("li").first().trigger("click");
            $(".email-bcc-searchbar").val("");
        }
        QuickSearch.handle_typing(QuickSearch.SEARCHTYPE.MEMBER, ".email-bcc-searchbar", ".email-bcc-searchbar-overlay", "email-bcc-searchbar-overlay-result", "#email-bcc");
    });
    $(".email-bcc-searchbar-overlay").on("focusout", function (){
        $(".email-bcc-searchbar-overlay").hide();
    })
    $(".email-bcc-searchbar-overlay").on("mouseleave", function (){
        $(".email-bcc-searchbar-overlay").hide();
    });
    $(".email-bcc-search").on("mouseenter", function (){
        $(".email-bcc-searchbar-overlay").show();
    });
    $(".email-bcc-search").on("focusin", function (){
        $(".email-bcc-searchbar-overlay").html("");
    });
    $(".email-bcc-searchbar").on("click", function (){
        $(".email-bcc-searchbar").val("");
    });
});

QuickSearch = (function(){
    const SEARCHTYPE = {
        MEMBER: 1,
    };
    var remove_email = function(){
        $(this).parent().remove();
    };
    var handle_typing = function(type, input, overlay, overlayresult, rec){
        if(type === 1){
            $(overlay).html("");
            $.ajax({
                url: '/api/members/',
                type: 'GET',
                data: {
                    "name": $(input).val()
                },
                contentType: 'application/json',
                success: function(data) {
                    if(is_ok(data)) {
                        $.each(data.members, function(index, value){
                            $(overlay).append("<li data-entity-id=\""+value.entity_id+"\" data-firstname=\""+value.firstname+"\" data-lastname=\""+value.lastname+"\" class=\"quicksearch-overlay-li list-group-item "+overlayresult+"\"><span>"+value.firstname+" "+value.lastname+"</span></li>")
                        });
                        $("."+overlayresult).off("click").on("click", function(){
                           $(rec).append("<span data-entity-id=\""+$(this).data("entity-id")+"\" class=\"badge badge-secondary\">"+$(this).data("firstname")+" "+$(this).data("lastname")+" <svg width=\"1.5em\" height=\"1.5em\" fill=\"currentColor\" class=\"remove-email\"><use xlink:href=\"/img/bootstrap-icons.svg#trash\"/></svg></span>");
                           $(".remove-email").unbind("click").on("click", QuickSearch.remove_email);
                        });
                    }
                },
                timeout: 3000,
                error: function() {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
            $(overlay).show();
        }else{
            console.log("Unkown searchtype: "+type);
        }
    };
    return{
        handle_typing: handle_typing,
        remove_email: remove_email,
        SEARCHTYPE: SEARCHTYPE,
    }
})();

Communicator = (function(){
   var load_groups = function(){
       $.ajax({
           url: '/api/groups?with_caller_permission=modules.communicator.email.send',
           type: 'GET',
           contentType: 'application/json',
           success: function(data) {
               if(is_ok(data)) {
                   $(data.groups).each(function(){
                       $(".group_selection_list").append("<span class=\"form-check group_selection_group\">\n" +
                           "                                                        <input type=\"checkbox\" class=\"form-check-input selected_group\" id=\""+this.group_id+"\" data-group-id=\""+this.group_id+"\">\n" +
                           "                                                        <label class=\"form-check-label\" for=\""+this.group_id+"\">"+this.name+"</label>\n" +
                           "                                                    </span>")
                   })
               }
           },
           timeout: 3000,
           error: function() {
               alert("Verbindung zum Server unterbrochen!");
           }
       });
   };
   var load_units = function(){
       $.ajax({
           url: '/api/units?with_caller_permission=modules.communicator.email.send',
           type: 'GET',
           contentType: 'application/json',
           success: function(data) {
               if(is_ok(data)) {
                   $(data).each(function(){
                       $(".unit_selection_list").append("<span class=\"form-check unit_selection_group\">\n" +
                           "                                                        <input type=\"checkbox\" class=\"form-check-input selected_unit\" id=\""+this.unit_id+"\" data-unit-id=\""+this.unit_id+"\" name=\"selected_groups\">" +
                           "                                                        <label class=\"form-check-label\" for=\""+this.unit_id+"\">"+this.name+"</label>\n" +
                           "                                                    </span>")
                   })
               }
           },
           timeout: 3000,
           error: function() {
               alert("Verbindung zum Server unterbrochen!");
           }
       });
   };
   var send_email = function(){
       var email = $();

       if($("#email-to > span").length > 0){
            email.to_members = [];
            $("#email-to > span").each(function(){email.to_members.push($(this).data("entity-id"))});
       }
       if($("#email-cc > span").length > 0){
           email.cc_members = [];
           $("#email-cc > span").each(function(){email.cc_members.push($(this).data("entity-id"))});
       }
       if($("#email-bcc > span").length > 0){
           email.bcc_members = [];
           $("#email-bcc > span").each(function(){email.bcc_members.push($(this).data("entity-id"))});
       }
       if($("#email-subject").val()){
           email.subject = $("#email-subject").val();
       }else{
           alert("Email konnte nicht gesendet werden: Es muss ein Betreff angegeben werden!");
           return;
       }
       if($("#email-body").val()){
           email.body = $("#email-body").val();
       }else{
           alert("Email konnte nicht gesendet werden: Die Nachricht darf nicht leer sein!");
           return;
       }

       email.selected_groups = [];
       email.selected_units = [];

       $(".selected_group").each(function(){
          if($(this).prop('checked')){
                email.selected_groups.push($(this).data("group-id"));
          }
       });

       $(".selected_unit").each(function(){
           if($(this).prop('checked')){
               email.selected_units.push($(this).data("unit-id"));
           }
       });

       $.ajax({
           url: '/api/communicator/email',
           type: 'POST',
           contentType: 'application/json',
           data: JSON.stringify(email),
           success: function(data) {
               if(is_ok(data)) {
                   $("#email-to").html("");
                   $("#email-cc").html("");
                   $("#email-bcc").html("");
                   $(".selected_group").prop("checked", false);
                   $(".selected_unit").prop("checked", false);
                   $("#email-subject").val("");
                   $("#email-body").val("");
                   $(".alert").append("<div class=\"alert alert-success\" role=\"alert\">Die Email wird nun versendet!</div>");
               }
           },
           timeout: 3000,
           error: function() {
               alert("Verbindung zum Server unterbrochen!");
           }
       });
   };
   var to_searchbar = function(){
       var searchterm = $("#email-to-searchbar").val();
       console.log(searchterm);
   };
   return{
       load_groups: load_groups,
       load_units: load_units,
       send_email: send_email,
       to_searchbar: to_searchbar,
   };
})();