$(document).ready(function () {
    DashboardModule.start();
    //Do not execute code here which relies on templates. Use EventUnitTemplateModule.start function instead
});

DashboardModule = (function () {
    let templates = {};
    let start = async function(){
        await load_templates();
        let etypes = await load_event_types_async();
        if(check_for_permission_async("modules.event_management.view")){
            let events = await load_events();
            $(events).each(function(){
                let etype = this.etype;
                let name;
                $(etypes).each(function(){
                    if(this.type_id === etype){
                        name = this.name;
                        return false;
                    }
                });
                this.etype_name = name;
            });
            $(".events_registered_future").append(templates.event_list(events));
        }
    };
    let load_templates = async function(){
        let res = await $.get("/templates/dashboard_event_list.hbs");
        templates.event_list = Handlebars.compile(res);
    };
    let load_events = async function(){
        const res = await $.ajax({
            url: '/api/events/members/'+$("#caller_id").val(),
            type: 'GET',
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            }
        });
        if (is_ok(res)) {
            return res;
        }
    };
    return{
        start: start,
    }
})();