function MiniSearchbar(pbase, pcallback, value_id, value_name, delete_callback){
    this.value_id = value_id;
    this.value_name = value_name
    this.base = pbase;
    this.callback = pcallback;
    this.searchbar = $("#"+this.base+"-searchbar");
    this.overlay = $("."+this.base+"-search-result-overlay");
    this.overlay_list = $("."+this.base+"-search-result-overlay-list");
    this.searchtype = this.searchbar.data("search-type");
    this.delete_callback = delete_callback;

    this.setup = function(){
        console.log('This function is deprecated. Please migrate to search2');
        var ms = this;

        if(ms.value_id && ms.value_name){
            $("#"+this.base).val(ms.value_name).data("entity-id", this.value_id).attr("data-entity-id", this.value_id);
            $("#"+this.base+"-search").hide();
            $("#"+this.base+"_input_group").show();
        }
        if(!ms.callback){
            if(ms.searchtype === "member"){
                ms.callback = function(caller){
                    $("#"+ms.base+"-search").hide();
                    $("#"+ms.base).val($(caller).data("firstname")+" "+$(caller).data("lastname")).attr("data-entity-id", $(caller).data("entity-id")).data("entity-id", $(caller).data("entity-id"));
                    $("#"+ms.base+"_input_group").show();
                }
            }else if(ms.searchtype === "organiser"){
                ms.callback = function(caller){
                    $("#"+ms.base+"-search").hide();
                    $("#"+ms.base).val($(caller).data("company")+": "+$(caller).data("firstname")+" "+$(caller).data("lastname")).attr("data-entity-id", $(caller).data("entity-id")).data("entity-id", $(caller).data("entity-id"));
                    $("#"+ms.base+"_input_group").show();
                }
            }else if(ms.searchtype === "template"){
                ms.callback = function(caller){
                    $("#"+ms.base+"-search").hide();
                    $("#"+ms.base).val($(caller).data("name")).attr("data-entity-id", $(caller).data("entity-id")).data("entity-id", $(caller).data("entity-id"));
                    $("#"+ms.base+"_input_group").show();
                }
            }else if(ms.searchtype === "vehicle"){
                ms.callback = function(caller){
                    $("#"+ms.base+"-search").hide();
                    $("#"+ms.base).val($(caller).data("identifier")).attr("data-entity-id", $(caller).data("entity-id")).data("entity-id", $(caller).data("entity-id"));
                    $("#"+ms.base+"_input_group").show();
                }
            }else if(ms.searchtype === "position"){
                ms.callback = function(caller){
                    $("#"+ms.base+"-search").hide();
                    let description = "";
                    if(caller.description){
                        description = " ("+caller.description+")"
                    }
                    $("#"+ms.base).val(caller.name+description).attr("data-entity-id", caller.entity_id);
                    $("#"+ms.base+"_input_group").show();
                }
            }else{
                console.log("unknown searchtype:"+ms.searchtype);
            }
        }
        $("#"+ms.base+"_remove").off("click").on("click", function(){
            ms.remove(ms);
            if (ms.delete_callback) {
                ms.delete_callback(this);
            }
        });
        $('body').click(function(evt){
            if(evt.target.class === ms.base+"-search-result-overlay")
                return;
            if($(evt.target).closest("."+ms.base+"-search-result-overlay").length)
                return;
            ms.overlay.hide();
            ms.searchbar.off("click").on("click", function(){
                ms.searchbar_onclick(ms);
            });
            ms.searchbar.off("keyup paste cut").on("keyup paste cut", function(){
                ms.searchbar_typing(ms);
            });
            ms.searchbar.off("mouseenter focusin").on("mouseenter focusin", function (){
                ms.overlay.show();
            });
            ms.overlay.off("mouseleave").on("mouseleave", function (){
                ms.overlay.hide();
            })
        })
    };
    this.remove = function(){
        $("#"+this.base+"_input_group").hide();
        $("#"+this.base).val("").removeData("entity-id").removeAttr("data-entity-id");
        $(this.searchbar).val("");
        $("#"+this.base+"-search").show();
    }
    this.searchbar_onclick = function(ms){
        ms.searchbar.val("");
        ms.overlay.show();
    };
    this.searchbar_typing = function(ms){
        ms.overlay.show();
        if(ms.searchtype === "member") {
            $.ajax({
                url: '/api/members/',
                type: 'GET',
                data: {
                    "name": ms.searchbar.val()
                },
                contentType: 'application/json',
                success: function (data) {
                    if (is_ok(data)) {
                        ms.overlay_list.html("");
                        $.each(data.members, function (index, value) {
                            ms.overlay_list.append("<span tabindex=\"0\" class=\"" + ms.base + "-search-result-overlay-result\" style=\"cursor: pointer\" data-group-id=\"" + value.group_id + "\" data-entity-id=\"" + value.entity_id + "\" data-firstname=\"" + value.firstname + "\" data-lastname=\"" + value.lastname + "\"><li class='list-group-item'><span class=\"badge badge-secondary\">Hinzufügen:</span> " + value.firstname + " " + value.lastname + "</li></span>")
                        });
                        //select search result on click
                        $("." + ms.base + "-search-result-overlay-result").off("click").on("click", function () {
                            ms.callback(this)
                        });
                        //select search result on enter key press
                        $("." + ms.base + "-search-result-overlay-result").off("keyup").on("keyup", function (e) {
                            if (e.keyCode === 13) {
                                ms.callback(this);
                            }
                        });
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }else if(ms.searchtype === "organiser"){
            $.ajax({
                url: '/api/event_organisers?q='+ms.searchbar.val(),
                type: 'GET',
                contentType: 'application/json',
                success: function (data) {
                    if (is_ok(data)) {
                        ms.overlay_list.html("");
                        $.each(data.organisers, function (index, value) {
                            ms.overlay_list.append("<span tabindex=\"0\" class=\"" + ms.base + "-search-result-overlay-result\" style=\"cursor: pointer\" data-entity-id=\"" + value.entity_id + "\" data-company=\"" + value.company + "\" data-firstname=\"" + value.firstname + "\" data-lastname=\"" + value.lastname + "\"><li class='list-group-item'><span class=\"badge badge-secondary\">Hinzufügen:</span> "+ value.company + " : "+value.firstname + " " + value.lastname + "</li></span>")
                        });
                        //select search result on click
                        $("." + ms.base + "-search-result-overlay-result").off("click").on("click", function () {
                            ms.callback(this)
                        });
                        //select search result on enter key press
                        $("." + ms.base + "-search-result-overlay-result").off("keyup").on("keyup", function (e) {
                            if (e.keyCode === 13) {
                                ms.callback(this);
                            }
                        });
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }else if(ms.searchtype === "position"){
            $.ajax({
                url: '/api/events/units/positions?q='+ms.searchbar.val(),
                type: 'GET',
                contentType: 'application/json',
                success: function (data) {
                    if (is_ok(data)) {
                        let res_map = new Map();

                        ms.overlay_list.html("");

                        $.each(data.positions, function (index, value) {
                            res_map.set(value.entity_id, value);
                            ms.overlay_list.append("<span tabindex=\"0\" class=\"" + ms.base + "-search-result-overlay-result\" style=\"cursor: pointer\" data-entity-id=\"" + value.entity_id+"\"><li class='list-group-item'><span class=\"badge badge-secondary\">Hinzufügen:</span> "+value.name+"</li></span>")
                        });

                        // We are using the new way to pass the data to the callback: Instead of using data attributes
                        // for each field we save all retrieved data in a Map (res_map) and pass the entry from
                        // this Map to the callback.
                        // TODO: implement this for each search type! But be careful, you will need to change every callback.

                        //select search result on click
                        $("." + ms.base + "-search-result-overlay-result").off("click").on("click", function () {
                            let res = res_map.get($(this).data("entity-id"));
                            ms.callback(res);
                        });
                        //select search result on enter key press
                        $("." + ms.base + "-search-result-overlay-result").off("keyup").on("keyup", function (e) {
                            if (e.keyCode === 13) {
                                let res = res_map.get($(this).data("entity-id"));
                                ms.callback(res);
                            }
                        });
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }else if(ms.searchtype === "template"){
            $.ajax({
                url: '/api/events/units/templates?q='+ms.searchbar.val(),
                type: 'GET',
                contentType: 'application/json',
                success: function (data) {
                    if (is_ok(data)) {
                        console.log(data);
                        ms.overlay_list.html("");
                        $.each(data.templates, function (index, value) {
                            ms.overlay_list.append("<span tabindex=\"0\" class=\"" + ms.base + "-search-result-overlay-result\" style=\"cursor: pointer\" data-entity-id=\"" + value.entity_id + "\" data-name=\"" + value.name + "\"><li class='list-group-item'><span class=\"badge badge-secondary\">Hinzufügen:</span> "+value.name+"</li></span>")
                        });
                        //select search result on click
                        $("." + ms.base + "-search-result-overlay-result").off("click").on("click", function () {
                            ms.callback(this)
                        });
                        //select search result on enter key press
                        $("." + ms.base + "-search-result-overlay-result").off("keyup").on("keyup", function (e) {
                            if (e.keyCode === 13) {
                                ms.callback(this);
                            }
                        });
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }else if(ms.searchtype === "vehicle"){
            $.ajax({
                url: '/api/resources/vehicles?q='+ms.searchbar.val(),
                type: 'GET',
                contentType: 'application/json',
                success: function (data) {
                    if (is_ok(data)) {
                        ms.overlay_list.html("");
                        $.each(data.vehicle_list, function (index, value) {
                            ms.overlay_list.append("<span tabindex=\"0\" class=\"" + ms.base + "-search-result-overlay-result\" style=\"cursor: pointer\" data-entity-id=\"" + value.entity_id + "\" data-identifier=\"" + value.identifier + "\"><li class='list-group-item'><span class=\"badge badge-secondary\">Hinzufügen:</span> "+value.identifier+"</li></span>")
                        });
                        //select search result on click
                        $("." + ms.base + "-search-result-overlay-result").off("click").on("click", function () {
                            ms.callback(this)
                        });
                        //select search result on enter key press
                        $("." + ms.base + "-search-result-overlay-result").off("keyup").on("keyup", function (e) {
                            if (e.keyCode === 13) {
                                ms.callback(this);
                            }
                        });
                    }

                },
                timeout: 3000,
                error: function () {
                    alert("Verbindung zum Server unterbrochen!");
                }
            });
        }
    };
}