$( document ).ready(function() {
   Scheduler.refresh_appointment_types();
   $(".scheduler_add_appointment_button").on("click", function(){
       Scheduler.add_appointment(this);
   });
});

Scheduler = ( function() {
    var appointment_types = [];
    var refresh_appointment_types = function(){
        $.ajax({
            type: "GET",
            url: "/api/appointments/types",
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    appointment_types = data;
                    $(data).each(function(){
                        $(".scheduler_appointment_types").append("<option value=\""+this.type_id+"\" data-interval=\""+this.interval+"\">"+this.name+"</option>")
                    })
                }
            }
        });
    };
    var add_appointment = function(submit){
        var appointment = {};
        var div = $(submit).parent();
        appointment.type_id = div.find(".scheduler_appointment_types").val();
        appointment.entity_id = div.find(".scheduler_add_appointment_entity_id").val();
        appointment.appointment_date = div.find(".scheduler_add_appointment_date").val();

        $.ajax({
            type: "POST",
            url: "/api/appointments",
            contentType: 'application/json',
            timeout: 3000,
            data: JSON.stringify(appointment),
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    let type = resolve_appointment_type(data.type_id);

                    $(".scheduler-tbody").append("<tr><td>"+type.name+"</td><td>"+data.appointment_date+"</td><td><button class='iconbutton scheduler_remove_appointment_button' data-appointment-id=\""+data.id+"\"><svg width=\"1.5em\" height=\"1.5em\" fill=\"currentColor\">\n" +
                        "<use xlink:href=\"/img/bootstrap-icons.svg#trash\"/>\n" +
                        "</svg></button></td></tr>");
                    $(".scheduler_remove_appointment_button").unbind().on("click", function(){
                        Scheduler.remove_appointment(this);
                    });
                }
            }
        });
    };
    var remove_appointment = function(button){
        var ap_id = $(button).data("appointment-id");
        console.log(ap_id);

        $.ajax({
            type: "DELETE",
            url: "/api/appointments/"+ap_id,
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    $(button).parent().parent().remove();
                }
            }
        });
    };
    var list_appointments = function(){
        var entity_id = $(".scheduler_add_appointment_entity_id").val();

        $.ajax({
            type: "GET",
            url: "/api/appointments?entity_id="+entity_id,
            contentType: 'application/json',
            timeout: 3000,
            error: function () {
                alert("Verbindung zum Server unterbrochen!");
            },
            success: function (data) {
                if(is_ok(data)) {
                    $(data).each(function(){
                        let type = resolve_appointment_type(this.type_id);
                        $(".scheduler-tbody").append("<tr><td>"+type.name+"</td><td>"+this.appointment_date+"</td><td><button class='iconbutton scheduler_remove_appointment_button' data-appointment-id=\""+this.id+"\"><svg width=\"1.5em\" height=\"1.5em\" fill=\"currentColor\">\n" +
                            "<use xlink:href=\"/img/bootstrap-icons.svg#trash\"/>\n" +
                            "</svg></button></td></tr>");
                    });
                    $(".scheduler_remove_appointment_button").unbind().on("click", function(){
                        Scheduler.remove_appointment(this);
                    });
                }
            }
        });
    };
    var resolve_appointment_type = function(type_id){
        var resolved = [];

        appointment_types.every(t => {
           if(t.type_id === type_id){
               resolved = t;
               return false;
           }else{
               return true;
           }
        });
        return resolved;
    };
    return{
        refresh_appointment_types: refresh_appointment_types,
        add_appointment: add_appointment,
        list_appointments: list_appointments,
        remove_appointment: remove_appointment,
    }
})();