use diesel::{Connection, PgConnection};
use rocket::State;

use crate::helper::settings::Settings;

pub fn establish_connection(settings: &State<Settings>) -> PgConnection {
    let db_url = settings.database.connection_string.clone();
    match PgConnection::establish(&db_url) {
        Ok(con) => con,
        Err(e) => {
            panic!("Couldn't connect to database: {}. Database offline?", e);
            //TODO: Return Error
        }
    }
}
