use diesel::sql_types::*;

#[derive(Queryable, QueryableByName, Clone, Deserialize, Serialize)]
pub struct RawMemberLicense {
    #[sql_type = "Text"]
    pub(crate) name: String,
    #[sql_type = "Nullable<Bool>"]
    pub(crate) drive_permission: Option<bool>,
    #[sql_type = "Nullable<Text>"]
    pub(crate) description: Option<String>,
}

#[derive(Queryable, QueryableByName, Clone, Deserialize, Serialize)]
pub struct LicenseCategory {
    #[sql_type = "Text"]
    pub(crate) name: String,
    #[sql_type = "Nullable<Text>"]
    pub(crate) description: Option<String>,
}

#[derive(Queryable, QueryableByName, Clone, Deserialize, Serialize)]
pub struct MemberDrivePermission {
    #[sql_type = "Uuid"]
    pub(crate) member_id: uuid::Uuid,
    #[sql_type = "Text"]
    pub(crate) license_name: String,
    #[sql_type = "Nullable<Bool>"]
    pub(crate) drive_permission: bool,
}