
use crate::schema::vehicles;

#[derive(Queryable, Clone, Deserialize, Serialize, AsChangeset, Insertable)]
#[table_name = "vehicles"]
#[changeset_options(treat_none_as_null = "true")]
#[primary_key(entity_id)]
pub struct Vehicle{
    pub(crate) entity_id: uuid::Uuid,
    pub(crate) identifier: String,
    pub(crate) numberplate: Option<String>,
    pub(crate) description: Option<String>,
    pub(crate) is_operational: bool,
    pub(crate) admissible_total_weight: Option<i32>,
    pub(crate) required_license: Option<String>,
    pub(crate) vehicle_category: Option<uuid::Uuid>,
}

#[derive(Queryable, Clone, Deserialize, Serialize)]
pub struct VehicleCategory{
    pub(crate) id: uuid::Uuid,
    pub(crate) name: String,
    pub(crate) description: Option<String>,
}

