use lettre::{AsyncTransport, Message};

use crate::helper::mail_queue::mailer::setup;
use crate::Settings;

pub async fn send_mail(mail: Message, settings: &Settings) -> Result<(), ()> {
    let mailer = match setup(settings) {
        Ok(res) => res,
        Err(e) => {
            error!("Error setting up  AsyncSmtpTransportBuilder: {}", e);
            return Err(());
        }
    };
    match mailer.send(mail).await {
        Ok(_) => Ok(()),
        Err(e) => {
            error!("Error sending E-mail: {}", e);
            Err(())
        }
    }
}